<?php
/*----------------------------------------------------------------------------------|  simontech.me  |----/

				Award Manager - Public Edition

/-------------------------------------------------------------------------------------------------------/



	@version		1.1.2.01
	@build			31st May, 2020
	@created		19th April, 2019

	@package		Award Manager

	@subpackage		script.php

	@author			SimonTech <https://simontech.me>

	@copyright		Copyright (C) 2019 SimonTech Development. All Rights Reserved

	@license		GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html

  ____  _____  _____  __  __  __      __       ___  _____  __  __  ____  _____  _  _  ____  _  _  ____

 (_  _)(  _  )(  _  )(  \/  )(  )    /__\     / __)(  _  )(  \/  )(  _ \(  _  )( \( )( ___)( \( )(_  _)

.-_)(   )(_)(  )(_)(  )    (  )(__  /(__)\   ( (__  )(_)(  )    (  )___/ )(_)(  )  (  )__)  )  (   )(

\____) (_____)(_____)(_/\/\_)(____)(__)(__)   \___)(_____)(_/\/\_)(__)  (_____)(_)\_)(____)(_)\_) (__)



/------------------------------------------------------------------------------------------------------*/



// No direct access to this file

defined('_JEXEC') or die('Restricted access');



JHTML::_('behavior.modal');



/**

 * Script File of Award_manager Component

 */

class com_award_managerInstallerScript

{

	/**

	 * method to install the component

	 *

	 * @return void

	 */

	function install($parent)

	{



	}



	/**

	 * method to uninstall the component

	 *

	 * @return void

	 */

	function uninstall($parent)

	{
		// Get Application object
		$app = JFactory::getApplication();

		// Get The Database object
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);
		// Select ids from fields
		$query->select($db->quoteName('id'));
		$query->from($db->quoteName('#__fields'));
		// Where nominee context is found
		$query->where( $db->quoteName('context') . ' = '. $db->quote('com_award_manager.nominee') );
		$db->setQuery($query);
		// Execute query to see if context is found
		$db->execute();
		$nominee_found = $db->getNumRows();
		// Now check if there were any rows
		if ($nominee_found)
		{
			// Since there are load the needed  nominee field ids
			$nominee_field_ids = $db->loadColumn();
			// Remove nominee from the field table
			$nominee_condition = array( $db->quoteName('context') . ' = '. $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__fields'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove nominee add queued success message.
				$app->enqueueMessage(JText::_('The fields with type (com_award_manager.nominee) context was removed from the <b>#__fields</b> table'));
			}
			// Also Remove nominee field values
			$nominee_condition = array( $db->quoteName('field_id') . ' IN ('. implode(',', $nominee_field_ids) .')');
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__fields_values'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove nominee field values
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove nominee add queued success message.
				$app->enqueueMessage(JText::_('The fields values for nominee was removed from the <b>#__fields_values</b> table'));
			}
		}

		// Create a new query object.
		$query = $db->getQuery(true);
		// Select ids from field groups
		$query->select($db->quoteName('id'));
		$query->from($db->quoteName('#__fields_groups'));
		// Where nominee context is found
		$query->where( $db->quoteName('context') . ' = '. $db->quote('com_award_manager.nominee') );
		$db->setQuery($query);
		// Execute query to see if context is found
		$db->execute();
		$nominee_found = $db->getNumRows();
		// Now check if there were any rows
		if ($nominee_found)
		{
			// Remove nominee from the field groups table
			$nominee_condition = array( $db->quoteName('context') . ' = '. $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__fields_groups'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove nominee add queued success message.
				$app->enqueueMessage(JText::_('The field groups with type (com_award_manager.nominee) context was removed from the <b>#__fields_groups</b> table'));
			}
		}

		// Create a new query object.
		$query = $db->getQuery(true);
		// Select id from content type table
		$query->select($db->quoteName('type_id'));
		$query->from($db->quoteName('#__content_types'));
		// Where nominee alias is found
		$query->where( $db->quoteName('type_alias') . ' = '. $db->quote('com_award_manager.nominee') );
		$db->setQuery($query);
		// Execute query to see if alias is found
		$db->execute();
		$nominee_found = $db->getNumRows();
		// Now check if there were any rows
		if ($nominee_found)
		{
			// Since there are load the needed  nominee type ids
			$nominee_ids = $db->loadColumn();
			// Remove nominee from the content type table
			$nominee_condition = array( $db->quoteName('type_alias') . ' = '. $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__content_types'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove nominee add queued success message.
				$app->enqueueMessage(JText::_('The (com_award_manager.nominee) type alias was removed from the <b>#__content_type</b> table'));
			}

			// Remove nominee items from the contentitem tag map table
			$nominee_condition = array( $db->quoteName('type_alias') . ' = '. $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__contentitem_tag_map'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove nominee add queued success message.
				$app->enqueueMessage(JText::_('The (com_award_manager.nominee) type alias was removed from the <b>#__contentitem_tag_map</b> table'));
			}

			// Remove nominee items from the ucm content table
			$nominee_condition = array( $db->quoteName('core_type_alias') . ' = ' . $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__ucm_content'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove nominee add queued success message.
				$app->enqueueMessage(JText::_('The (com_award_manager.nominee) type alias was removed from the <b>#__ucm_content</b> table'));
			}

			// Make sure that all the nominee items are cleared from DB
			foreach ($nominee_ids as $nominee_id)
			{
				// Remove nominee items from the ucm base table
				$nominee_condition = array( $db->quoteName('ucm_type_id') . ' = ' . $nominee_id);
				// Create a new query object.
				$query = $db->getQuery(true);
				$query->delete($db->quoteName('#__ucm_base'));
				$query->where($nominee_condition);
				$db->setQuery($query);
				// Execute the query to remove nominee items
				$db->execute();

				// Remove nominee items from the ucm history table
				$nominee_condition = array( $db->quoteName('ucm_type_id') . ' = ' . $nominee_id);
				// Create a new query object.
				$query = $db->getQuery(true);
				$query->delete($db->quoteName('#__ucm_history'));
				$query->where($nominee_condition);
				$db->setQuery($query);
				// Execute the query to remove nominee items
				$db->execute();
			}
		}

		// Create a new query object.
		$query = $db->getQuery(true);
		// Select id from content type table
		$query->select($db->quoteName('type_id'));
		$query->from($db->quoteName('#__content_types'));
		// Where Nominee alias is found
		$query->where( $db->quoteName('type_alias') . ' = '. $db->quote('com_award_manager.nominee') );
		$db->setQuery($query);
		// Execute query to see if alias is found
		$db->execute();
		$nominee_found = $db->getNumRows();
		// Now check if there were any rows
		if ($nominee_found)
		{
			// Since there are load the needed  nominee type ids
			$nominee_ids = $db->loadColumn();
			// Remove Nominee from the content type table
			$nominee_condition = array( $db->quoteName('type_alias') . ' = '. $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__content_types'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove Nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove Nominee add queued success message.
				$app->enqueueMessage(JText::_('The (com_award_manager.nominee) type alias was removed from the <b>#__content_type</b> table'));
			}

			// Remove Nominee items from the contentitem tag map table
			$nominee_condition = array( $db->quoteName('type_alias') . ' = '. $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__contentitem_tag_map'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove Nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove Nominee add queued success message.
				$app->enqueueMessage(JText::_('The (com_award_manager.nominee) type alias was removed from the <b>#__contentitem_tag_map</b> table'));
			}

			// Remove Nominee items from the ucm content table
			$nominee_condition = array( $db->quoteName('core_type_alias') . ' = ' . $db->quote('com_award_manager.nominee') );
			// Create a new query object.
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__ucm_content'));
			$query->where($nominee_condition);
			$db->setQuery($query);
			// Execute the query to remove Nominee items
			$nominee_done = $db->execute();
			if ($nominee_done)
			{
				// If succesfully remove Nominee add queued success message.
				$app->enqueueMessage(JText::_('The (com_award_manager.nominee) type alias was removed from the <b>#__ucm_content</b> table'));
			}

			// Make sure that all the Nominee items are cleared from DB
			foreach ($nominee_ids as $nominee_id)
			{
				// Remove Nominee items from the ucm base table
				$nominee_condition = array( $db->quoteName('ucm_type_id') . ' = ' . $nominee_id);
				// Create a new query object.
				$query = $db->getQuery(true);
				$query->delete($db->quoteName('#__ucm_base'));
				$query->where($nominee_condition);
				$db->setQuery($query);
				// Execute the query to remove Nominee items
				$db->execute();

				// Remove Nominee items from the ucm history table
				$nominee_condition = array( $db->quoteName('ucm_type_id') . ' = ' . $nominee_id);
				// Create a new query object.
				$query = $db->getQuery(true);
				$query->delete($db->quoteName('#__ucm_history'));
				$query->where($nominee_condition);
				$db->setQuery($query);
				// Execute the query to remove Nominee items
				$db->execute();
			}
		}

		// If All related items was removed queued success message.
		$app->enqueueMessage(JText::_('All related items was removed from the <b>#__ucm_base</b> table'));
		$app->enqueueMessage(JText::_('All related items was removed from the <b>#__ucm_history</b> table'));

		// Remove award_manager assets from the assets table
		$award_manager_condition = array( $db->quoteName('name') . ' LIKE ' . $db->quote('com_award_manager%') );

		// Create a new query object.
		$query = $db->getQuery(true);
		$query->delete($db->quoteName('#__assets'));
		$query->where($award_manager_condition);
		$db->setQuery($query);
		$nominee_done = $db->execute();
		if ($nominee_done)
		{
			// If succesfully remove award_manager add queued success message.
			$app->enqueueMessage(JText::_('All related items was removed from the <b>#__assets</b> table'));
		}


		// little notice as after service, in case of bad experience with component.

		echo '<h2>Did something go wrong? Are you disappointed?</h2>

		<p>Please let me know at <a href="mailto:tech@teucg.com">tech@teucg.com</a>.

		<br />We at SimonTech Development are committed to building extensions that performs proficiently! You can help us, really!

		<br />Send me your thoughts on improvements that is needed, trust me, I will be very grateful!

		<br />Visit us at <a href="https://simontech.me/support/open-support-ticket?view=Categories" target="_blank">https://simontech.me</a> today!</p>';

	}



	/**

	 * method to update the component

	 *

	 * @return void

	 */

	function update($parent)

	{



	}



	/**

	 * method to run before an install/update/uninstall method

	 *

	 * @return void

	 */

	function preflight($type, $parent)

	{

		// get application

		$app = JFactory::getApplication();

		// is redundant ...hmmm

		if ($type == 'uninstall')

		{

			return true;

		}

		// the default for both install and update

		$jversion = new JVersion();

		if (!$jversion->isCompatible('3.6.0'))

		{

			$app->enqueueMessage('Please upgrade to at least Joomla! 3.6.0 before continuing!', 'error');

			return false;

		}

		// do any updates needed

		if ($type == 'update')

		{

		}

		// do any install needed

		if ($type == 'install')

		{

		}

	}



	/**

	 * method to run after an install/update/uninstall method

	 *

	 * @return void

	 */

	function postflight($type, $parent)

	{

		// get application

		$app = JFactory::getApplication();

		// set the default component settings

		if ($type == 'install')

		{

			// Get The Database object
			$db = JFactory::getDbo();

			// Create the nominee content type object.
			$nominee = new stdClass();
			$nominee->type_title = 'Award_manager Nominee';
			$nominee->type_alias = 'com_award_manager.nominee';
			$nominee->table = '{"special": {"dbtable": "#__award_manager_nominee","key": "id","type": "Nominee","prefix": "award_managerTable","config": "array()"},"common": {"dbtable": "#__ucm_content","key": "ucm_id","type": "Corecontent","prefix": "JTable","config": "array()"}}';
			$nominee->field_mappings = '{"common": {"core_content_item_id": "id","core_title": "firstname","core_state": "published","core_alias": "null","core_created_time": "created","core_modified_time": "modified","core_body": "null","core_hits": "hits","core_publish_up": "null","core_publish_down": "null","core_access": "access","core_params": "params","core_featured": "null","core_metadata": "null","core_language": "null","core_images": "null","core_urls": "null","core_version": "version","core_ordering": "ordering","core_metakey": "null","core_metadesc": "null","core_catid": "null","core_xreference": "null","asset_id": "asset_id"},"special": {"firstname":"firstname","title":"title","lastname":"lastname","parentemail":"parentemail","type":"type","dateofbirth":"dateofbirth","agentphone":"agentphone","script":"script","videoinfo":"videoinfo","lifestyle_image":"lifestyle_image","mpthree":"mpthree","socmed":"socmed","headshot_image":"headshot_image","agentemail":"agentemail","imdbinfo":"imdbinfo","projage":"projage","telnumber":"telnumber","parent":"parent","cntry":"cntry","cityst":"cityst","agentweb":"agentweb","character":"character","noms":"noms","roletype":"roletype","awds":"awds","airdate":"airdate","distribco":"distribco","projlink":"projlink","callsheet":"callsheet","info":"info","ytvimlink":"ytvimlink","agentname":"agentname","meminfo":"meminfo","agentadd":"agentadd"}}';
			$nominee->router = 'Award_managerHelperRoute::getNomineeRoute';
			$nominee->content_history_options = '{"formFile": "administrator/components/com_award_manager/models/forms/nominee.xml","hideFields": ["asset_id","checked_out","checked_out_time","version","lifestyle_image","headshot_image"],"ignoreChanges": ["modified_by","modified","checked_out","checked_out_time","version","hits"],"convertToInt": ["published","ordering","projage","noms","awds"],"displayLookup": [{"sourceColumn": "created_by","targetTable": "#__users","targetColumn": "id","displayColumn": "name"},{"sourceColumn": "access","targetTable": "#__viewlevels","targetColumn": "id","displayColumn": "title"},{"sourceColumn": "modified_by","targetTable": "#__users","targetColumn": "id","displayColumn": "name"}]}';

			// Set the object into the content types table.
			$nominee_Inserted = $db->insertObject('#__content_types', $nominee);


			// Install the global extenstion assets permission.
			$query = $db->getQuery(true);
			// Field to update.
			$fields = array(
				$db->quoteName('rules') . ' = ' . $db->quote('{"site.nominees.access":{"1":1}}'),
			);
			// Condition.
			$conditions = array(
				$db->quoteName('name') . ' = ' . $db->quote('com_award_manager')
			);
			$query->update($db->quoteName('#__assets'))->set($fields)->where($conditions);
			$db->setQuery($query);
			$allDone = $db->execute();

			// Install the global extenstion params.
			$query = $db->getQuery(true);
			// Field to update.
			$fields = array(
				$db->quoteName('params') . ' = ' . $db->quote('{"autorName":"SimonTech","autorEmail":"tech@teucg.com","save_history":"1","history_limit":"10","uikit_load":"1","uikit_min":""}'),
			);
			// Condition.
			$conditions = array(
				$db->quoteName('element') . ' = ' . $db->quote('com_award_manager')
			);
			$query->update($db->quoteName('#__extensions'))->set($fields)->where($conditions);
			$db->setQuery($query);
			$allDone = $db->execute();

			echo '<a target="_blank" href="https://simontech.me" title="Award Manager">
				<img src="components/com_award_manager/assets/images/logo-component.png"/>
				</a>';

		}

		// do any updates needed

		if ($type == 'update')

		{

			// Get The Database object
			$db = JFactory::getDbo();

			// Create the nominee content type object.
			$nominee = new stdClass();
			$nominee->type_title = 'Award_manager Nominee';
			$nominee->type_alias = 'com_award_manager.nominee';
			$nominee->table = '{"special": {"dbtable": "#__award_manager_nominee","key": "id","type": "Nominee","prefix": "award_managerTable","config": "array()"},"common": {"dbtable": "#__ucm_content","key": "ucm_id","type": "Corecontent","prefix": "JTable","config": "array()"}}';
			$nominee->field_mappings = '{"common": {"core_content_item_id": "id","core_title": "firstname","core_state": "published","core_alias": "null","core_created_time": "created","core_modified_time": "modified","core_body": "null","core_hits": "hits","core_publish_up": "null","core_publish_down": "null","core_access": "access","core_params": "params","core_featured": "null","core_metadata": "null","core_language": "null","core_images": "null","core_urls": "null","core_version": "version","core_ordering": "ordering","core_metakey": "null","core_metadesc": "null","core_catid": "null","core_xreference": "null","asset_id": "asset_id"},"special": {"firstname":"firstname","title":"title","lastname":"lastname","parentemail":"parentemail","type":"type","dateofbirth":"dateofbirth","agentphone":"agentphone","script":"script","videoinfo":"videoinfo","lifestyle_image":"lifestyle_image","mpthree":"mpthree","socmed":"socmed","headshot_image":"headshot_image","agentemail":"agentemail","imdbinfo":"imdbinfo","projage":"projage","telnumber":"telnumber","parent":"parent","cntry":"cntry","cityst":"cityst","agentweb":"agentweb","character":"character","noms":"noms","roletype":"roletype","awds":"awds","airdate":"airdate","distribco":"distribco","projlink":"projlink","callsheet":"callsheet","info":"info","ytvimlink":"ytvimlink","agentname":"agentname","meminfo":"meminfo","agentadd":"agentadd"}}';
			$nominee->router = 'Award_managerHelperRoute::getNomineeRoute';
			$nominee->content_history_options = '{"formFile": "administrator/components/com_award_manager/models/forms/nominee.xml","hideFields": ["asset_id","checked_out","checked_out_time","version","lifestyle_image","headshot_image"],"ignoreChanges": ["modified_by","modified","checked_out","checked_out_time","version","hits"],"convertToInt": ["published","ordering","projage","noms","awds"],"displayLookup": [{"sourceColumn": "created_by","targetTable": "#__users","targetColumn": "id","displayColumn": "name"},{"sourceColumn": "access","targetTable": "#__viewlevels","targetColumn": "id","displayColumn": "title"},{"sourceColumn": "modified_by","targetTable": "#__users","targetColumn": "id","displayColumn": "name"}]}';

			// Check if nominee type is already in content_type DB.
			$nominee_id = null;
			$query = $db->getQuery(true);
			$query->select($db->quoteName(array('type_id')));
			$query->from($db->quoteName('#__content_types'));
			$query->where($db->quoteName('type_alias') . ' LIKE '. $db->quote($nominee->type_alias));
			$db->setQuery($query);
			$db->execute();

			// Set the object into the content types table.
			if ($db->getNumRows())
			{
				$nominee->type_id = $db->loadResult();
				$nominee_Updated = $db->updateObject('#__content_types', $nominee, 'type_id');
			}
			else
			{
				$nominee_Inserted = $db->insertObject('#__content_types', $nominee);
			}


			echo '<a target="_blank" href="https://simontech.me" title="Award Manager">
				<img src="components/com_award_manager/assets/images/logo-component.png"/>
				</a>
				<h3>Upgrade to Version 1.1.2.01 Was Successful! Let us know if anything is not working as expected.</h3>';

		}

	}

}

